/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.ui;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.DialogInterface.OnDismissListener;
import android.content.Intent;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.PowerManager;
import android.provider.Settings;
import android.view.Window;
import android.view.WindowManager;

import net.micode.notes.R;
import net.micode.notes.data.Notes;
import net.micode.notes.tool.DataUtils;

import java.io.IOException;

/**
 * 闹钟提醒活动类，继承自Activity，实现了OnClickListener和OnDismissListener接口。
 * 该活动用于在闹钟响起时显示提醒对话框，并播放默认的闹钟声音。
 */
public class AlarmAlertActivity extends Activity implements OnClickListener, OnDismissListener {
    private long mNoteId; // 保存笔记的ID
    private String mSnippet; // 保存笔记的摘要
    private static final int SNIPPET_PREW_MAX_LEN = 60; // 笔记摘要的最大长度
    MediaPlayer mPlayer; // 用于播放闹钟声音的MediaPlayer实例

    /**
     * 创建活动时调用的方法。
     * @param savedInstanceState 保存的实例状态数据包
     */
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE); // 请求无标题窗口

        final Window win = getWindow(); // 获取当前窗口
        win.addFlags(WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED); // 设置窗口在锁屏时显示

        // 如果屏幕未点亮，则添加更多标志以保持屏幕点亮并允许在锁屏时操作
        if (!isScreenOn()) {
            win.addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON
                    | WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON
                    | WindowManager.LayoutParams.FLAG_ALLOW_LOCK_WHILE_SCREEN_ON
                    | WindowManager.LayoutParams.FLAG_LAYOUT_INSET_DECOR);
        }

        Intent intent = getIntent(); // 获取启动该活动的Intent

        try {
            mNoteId = Long.valueOf(intent.getData().getPathSegments().get(1)); // 从Intent中提取笔记ID
            mSnippet = DataUtils.getSnippetById(this.getContentResolver(), mNoteId); // 根据笔记ID获取摘要
            // 如果摘要长度超过最大限制，则截取前SNIPPET_PREW_MAX_LEN个字符并添加省略号
            mSnippet = mSnippet.length() > SNIPPET_PREW_MAX_LEN ? mSnippet.substring(0,
                    SNIPPET_PREW_MAX_LEN) + getResources().getString(R.string.notelist_string_info)
                    : mSnippet;
        } catch (IllegalArgumentException e) {
            e.printStackTrace(); // 打印异常信息
            return; // 如果发生异常，则结束该方法
        }

        mPlayer = new MediaPlayer(); // 创建MediaPlayer实例
        // 检查数据库中是否存在指定ID的笔记
        if (DataUtils.visibleInNoteDatabase(getContentResolver(), mNoteId, Notes.TYPE_NOTE)) {
            showActionDialog(); // 显示操作对话框
            playAlarmSound(); // 播放闹钟声音
        } else {
            finish(); // 如果笔记不存在，则结束该活动
        }
    }

    /**
     * 检查屏幕是否点亮。
     * @return 如果屏幕点亮则返回true，否则返回false
     */
    private boolean isScreenOn() {
        PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE); // 获取电源管理服务
        return pm.isScreenOn(); // 返回屏幕是否点亮的状态
    }

    /**
     * 播放闹钟声音的方法。
     */
    private void playAlarmSound() {
        // 获取实际的默认闹钟铃声URI
        Uri url = RingtoneManager.getActualDefaultRingtoneUri(this, RingtoneManager.TYPE_ALARM);

        // 获取当前设置的静音模式影响的音频流类型
        int silentModeStreams = Settings.System.getInt(getContentResolver(),
                Settings.System.MODE_RINGER_STREAMS_AFFECTED, 0);

        // 如果静音模式影响了闹钟音频流，则设置MediaPlayer的音频流类型为silentModeStreams
        // 否则，设置为AudioManager.STREAM_ALARM
        if ((silentModeStreams & (1 << AudioManager.STREAM_ALARM)) != 0) {
            mPlayer.setAudioStreamType(silentModeStreams);
        } else {
            mPlayer.setAudioStreamType(AudioManager.STREAM_ALARM);
        }
        try {
            mPlayer.setDataSource(this, url); // 设置MediaPlayer的数据源为闹钟铃声URI
            mPlayer.prepare(); // 准备MediaPlayer
            mPlayer.setLooping(true); // 设置MediaPlayer循环播放
            mPlayer.start(); // 开始播放闹钟声音
        } catch (IllegalArgumentException e) {
            e.printStackTrace(); // 打印异常信息
        } catch (SecurityException e) {
            e.printStackTrace(); // 打印异常信息
        } catch (IllegalStateException e) {
            e.printStackTrace(); // 打印异常信息
        } catch (IOException e) {
            e.printStackTrace(); // 打印异常信息
        }
    }

    /**
     * 显示操作对话框的方法。
     */
    private void showActionDialog() {
        AlertDialog.Builder dialog = new AlertDialog.Builder(this); // 创建AlertDialog.Builder实例
        dialog.setTitle(R.string.app_name); // 设置对话框标题为应用名称
        dialog.setMessage(mSnippet); // 设置对话框消息为笔记摘要
        dialog.setPositiveButton(R.string.notealert_ok, this); // 设置确定按钮及其监听器
        // 如果屏幕已点亮，则添加进入按钮及其监听器
        if (isScreenOn()) {
            dialog.setNegativeButton(R.string.notealert_enter, this);
        }
        dialog.show().setOnDismissListener(this); // 显示对话框并设置对话框消失监听器
    }

    /**
     * 实现OnClickListener接口的方法，处理对话框按钮点击事件。
     * @param dialog 触发点击事件的对话框
     * @param which 点击的按钮的ID
     */
    public void onClick(DialogInterface dialog, int which) {
        switch (which) {
            case DialogInterface.BUTTON_NEGATIVE:
                Intent intent = new Intent(this, NoteEditActivity.class); // 创建Intent准备跳转到笔记编辑活动
                intent.setAction(Intent.ACTION_VIEW); // 设置Intent动作类型为ACTION_VIEW
                intent.putExtra(Intent.EXTRA_UID, mNoteId); // 添加笔记ID作为附加信息
                startActivity(intent); // 启动笔记编辑活动
                break;
            default:
                break;
        }
    }

    /**
     * 实现OnDismissListener接口的方法，处理对话框消失事件。
     * @param dialog 消失的对话框
     */
    public void onDismiss(DialogInterface dialog) {
        stopAlarmSound(); // 停止播放闹钟声音
        finish(); // 结束该活动
    }

    /**
     * 停止并释放MediaPlayer的方法。
     */
    private void stopAlarmSound() {
        if (mPlayer != null) {
            mPlayer.stop(); // 停止MediaPlayer播放
            mPlayer.release(); // 释放MediaPlayer资源
            mPlayer = null; // 将mPlayer置为null
        }
    }
}
